//+------------------------------------------------------------------+
//|                                             RegressionSignal.mqh |
//+------------------------------------------------------------------+
#property link      "https://enterboldly.com"
#property version   "1.00"
#property strict
#include <UserClass\Regression.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class RegressionSignal : public Regression
  {
private:

public:
datetime             last_time;
   bool              TraceEnabled;
                     RegressionSignal();
   int               Signal(int _left_bar);
   bool              NewBar();
   bool              PlacePriceLine(int _chart,int _frombar,double _fromprice,int _tobar,double _toprice,int _color,int _left_bar);
                    ~RegressionSignal();
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
RegressionSignal::RegressionSignal()
  {
  TraceEnabled=false;
  last_time=0;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int RegressionSignal::Signal(int _left_bar)
  {
   int left_bar=_left_bar; //this is 10 x M15
   int right_bar=1;
   double price_array_close[];
   ArrayResize(price_array_close,left_bar+1,0);  //assume we are sending from 100 to 0 therefore 101
                                                 //ArraySetAsSeries(price_array_close,true);
   if(NewBar())
     {
      for(int i=0;i<=left_bar;i++)
        {
         price_array_close[i]=Close[i];
         //Print(i,",",Close[i]);
        }
      RegressionCalc(price_array_close,left_bar,1);
      if (TraceEnabled) Print("left: ",left_bar,"  slope: ",GetSlope(),"  left: ",GetLeftMost(),"  right: ",GetRightMost() );
      PlacePriceLine(0,left_bar,GetLeftMost(),1,GetRightMost(),Gray+left_bar*13,left_bar);
     }

   if(GetSlope()>0)
      return (1);

   if(GetSlope()<0)
      return (-1);

   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool RegressionSignal::NewBar() /* add this to the front end still */
  {
   if(Time[0]!=last_time)
     {
      last_time=Time[0];
      return(true);
     }
   else
     {
      return(false);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool RegressionSignal::PlacePriceLine(int _chart,int _frombar,double _fromprice,int _tobar,double _toprice,int _color,int _left_bar)
  {
   string object_name="RegressionLineSignal-"+IntegerToString(_left_bar,4,'~');

   ObjectDelete(object_name);
   ObjectCreate(0,object_name,OBJ_TREND,_chart,Time[_frombar],_fromprice,Time[_tobar],_toprice);
   ObjectSet(object_name,OBJPROP_RAY,false);
   ObjectSetInteger(0,object_name,OBJPROP_COLOR,_color);

   return true;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
RegressionSignal::~RegressionSignal()
  {
  }
//+------------------------------------------------------------------+
